
Page({
  data: {
    scrollHeight: 0, //scroll-view高度
    pageIndex: 0, //页码
    totalRecord: 0, //图书总数
    isInit: true, //是否第一次进入应用
    loadingMore: false, //是否正在加载更多
    pageData: [], //图书数据
    searchKey: null //搜索关键字
  },

  //页面显示获取设备屏幕高度，以适配scroll-view组件高度
  onShow() {
    wx.getSystemInfo({
      success: (res) => {
        //80为顶部搜索框区域高度 rpx转px 屏幕宽度/750
        this.setData({
          scrollHeight: res.windowHeight - (100 * res.windowWidth / 750)
        });
      }
    })
  },

  //搜索输入框输入取值
  searchInputEvent(e) {
    this.setData({
      searchKey: e.detail.value
    });
  },

  //搜索按钮点击事件
  searchClickEvent(e) {
    if (!this.data.searchKey) {
      wx.showToast({
        title: '请输出入书名',
        icon: 'none',
        duration: 1000
      });
      return;
    }
    this.setData({
      pageIndex: 0,
      pageData: []
    });

    // 从数据库中查找图书数据
    const q = this.data.searchKey;
    const start = this.data.pageIndex;

    this.setData({
      loadingMore: true,
      isInit: false
    });

    wx.showLoading({
      title: '加载中',
    });

    const db = wx.cloud.database()
    // 查询当前用户所有的 counters
    // where中利用正则db.RegExp实现了模糊查询
    // 如果注意在导入项目时要确保云数据库中书籍信息的字段_openid和当前登录的小程序的openid一致
    db.collection('books').where({
      title: db.RegExp({
        regexp: q,
        options: 'i',
      }),
    }).get({
      success: res => {
        this.setData({
          loadingMore: false,
          pageData: res.data,
          pageIndex: start + 1,
          totalRecord: res.data.length
        });
        console.log('[数据库] [查询记录] 成功: ', res)
      },
      fail: err => {
        wx.showToast({
          icon: 'none',
          title: '查询记录失败'
        })
        console.error('[数据库] [查询记录] 失败：', err)
      }
    })
    wx.hideLoading();
  },

  //下拉请求数据
  scrollLowerEvent(e) {
    !this.data.loadingMore && requestData.call(this);
  },

  //跳转到详细页面
  toDetailPage(e) {
    const bid = e.currentTarget.dataset.bid; //图书id [data-bid]
    console.log("bid")
    console.log(bid)
    wx.navigateTo({
      url: `../detail/detail?id=${bid}`
    });
  }

});
